VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "Mscomm32.ocx"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form VB6miniTerm 
   Caption         =   "VB6miniTerm"
   ClientHeight    =   9480
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   11190
   LinkTopic       =   "Form1"
   ScaleHeight     =   9480
   ScaleWidth      =   11190
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGet 
      Caption         =   "Get file from SD"
      Height          =   495
      Left            =   8400
      TabIndex        =   10
      Top             =   7440
      Width           =   2655
   End
   Begin VB.CommandButton cmdPut 
      Caption         =   "Put file  to  SD"
      Height          =   495
      Left            =   8400
      TabIndex        =   9
      Top             =   8040
      Width           =   2655
   End
   Begin VB.CommandButton cmdPause 
      Caption         =   "Pause"
      Height          =   375
      Left            =   8880
      TabIndex        =   8
      Top             =   8640
      Width           =   975
   End
   Begin VB.CheckBox chkEcho 
      Caption         =   "Echo"
      Height          =   255
      Left            =   6720
      TabIndex        =   7
      Top             =   8760
      Width           =   735
   End
   Begin VB.CheckBox chkRTS 
      Caption         =   "RTS"
      Height          =   255
      Left            =   5760
      TabIndex        =   6
      Top             =   8880
      Width           =   735
   End
   Begin VB.CheckBox chkDTR 
      Caption         =   "DTR"
      Height          =   255
      Left            =   5760
      TabIndex        =   5
      Top             =   8520
      Width           =   735
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   375
      Left            =   7680
      TabIndex        =   4
      Top             =   8640
      Width           =   975
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "Enable"
      Height          =   375
      Left            =   10080
      TabIndex        =   3
      Top             =   8640
      Width           =   975
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   1320
      Top             =   8520
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      OutBufferSize   =   1024
      BaudRate        =   115200
      InputMode       =   1
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   8640
      Width           =   975
   End
   Begin VB.Frame fraCom1 
      Caption         =   "COM"
      Height          =   6975
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   10935
      Begin VB.TextBox txtCom1 
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   6615
         Left            =   120
         MultiLine       =   -1  'True
         ScrollBars      =   3  'Both
         TabIndex        =   1
         Top             =   240
         Width           =   10680
      End
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   1920
      Top             =   8520
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
End
Attribute VB_Name = "VB6miniTerm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'******************************************************************************
'*   VB6 Minimal Terminal Program                                             *
'*   (c) 2013 Ray Rodrick (Cluso99)                                           *
'******************************************************************************

' RR20130130    VB6 Minimal Terminal Program
' font Courier New 8 (Terminal 9 smaller)
' RR20130131    add FTF code back in
' RR20130208    GET working (<cr>A<lf> out of order bug)

Const commportno As Integer = 4
Const baud       As String = "115200,N,8,1"
Const dirname    As String = "D:\VB6\AHC\"
Const comsize    As Long = 256                              ' comms data block size

Dim buf As String                                           ' comms read buffer
Dim bMainLoop As Boolean

    Option Explicit

Private Sub cmdGet_Click()
' Get a file from SD to the PC
    If Not MSComm1.PortOpen Then Exit Sub                   ' must be open
    GetFile
    bMainLoop = True
    txtCom1.SetFocus
End Sub

Private Sub cmdPut_Click()
' Put a file to SD from the PC
    If Not MSComm1.PortOpen Then Exit Sub                   ' must be open
    PutFile
    bMainLoop = True
    txtCom1.SetFocus
End Sub

Private Sub txtCom1_KeyPress(KeyAscii As Integer)
    If chkEcho.Value = vbChecked Then
        DisplayText (Chr(KeyAscii))                         ' echo
    End If
    MSComm1.Output = Chr(KeyAscii)
    KeyAscii = 0
End Sub

Private Sub cmdClear_Click()
    txtCom1.Text = ""                                       ' clear contents
    txtCom1.SetFocus
End Sub

Private Sub cmdOpen_Click()
    If cmdOpen.Caption = "Enable" Then
        cmdOpen.Caption = "Disable"
        OpenCommPort (commportno)
        txtCom1.SetFocus
        bMainLoop = True
        MainLoop                                            ' something wrong with doing this here!!!
    Else
        cmdOpen.Caption = "Enable"
        CloseCommPort
        txtCom1.SetFocus
    End If
End Sub

Private Sub cmdClose_Click()
    CloseCommPort
    txtCom1.SetFocus
End Sub

Private Sub chkDTR_Click()
    If MSComm1.PortOpen Then
        If chkDTR.Value = vbUnchecked Then
            MSComm1.DTREnable = True
        Else
            MSComm1.DTREnable = False
        End If
    End If
    txtCom1.SetFocus
End Sub

Private Sub chkRTS_Click()
    If MSComm1.PortOpen Then
        If chkRTS.Value = vbUnchecked Then
            MSComm1.RTSEnable = True
        Else
            MSComm1.RTSEnable = False
        End If
    End If
    txtCom1.SetFocus
End Sub

Private Sub chkEcho_Click()
    txtCom1.SetFocus
End Sub

Private Sub cmdExit_Click()
    CloseCommPort
    Unload Me
End Sub

Private Sub Form_Load()
'    fcount = 1
End Sub

Private Sub MainLoop()
Dim str, str2 As String
Dim i As Long
    Do While MSComm1.PortOpen
        If bMainLoop Then                                   ' skip during get/put FTF
            If MSComm1.InBufferCount > 0 Then
                str = MSComm1.Input
                str2 = ""
                    ' change cr to crlf
                    For i = 1 To Len(str)
                        str2 = str2 + Mid(str, i, 1)
                        If Mid(str, i, 1) = Chr(13) Then
                            str2 = str2 + Chr(10)
                        End If
                    Next i
                DisplayText (str2)
            End If
            DoEvents
        End If
    Loop
End Sub

Private Sub OpenCommPort(portno)
Dim str As String
    If MSComm1.PortOpen Then Exit Sub
    MSComm1.CommPort = portno
    MSComm1.Settings = baud
    MSComm1.InputMode = comInputModeText
    MSComm1.InputLen = 0                                    ' read entire buffer when Input is used
    MSComm1.PortOpen = True                                 ' Open the port
    str = MSComm1.Input                                     ' ensure buffer clear
    DisplayText ("i) CommPort " & portno & " opened" & vbCrLf)
    fraCom1.Caption = "COM " & portno & " "
    fraCom1.Refresh
    buf = ""                                                ' clear the input buffer
End Sub

Private Function ReadCommPort(size) As String
    ' wait for 'n' bytes (need timeout!!!===========)
    Do
        DoEvents
    Loop Until MSComm1.InBufferCount >= (size - Len(buf))
    buf = buf & MSComm1.Input                               ' read whatever is avail
    ReadCommPort = Left(buf, size)                          ' return the required length string
    buf = Mid(buf, size + 1)                                '  and remove from buf
End Function

Private Sub CloseCommPort()
    If MSComm1.PortOpen Then
        MSComm1.PortOpen = False                            ' if open then close it
        DisplayText (vbCrLf & "i) CommPort " & commportno & " closed" & vbCrLf)
        fraCom1.Caption = "COM "
        fraCom1.Refresh
    End If
    cmdOpen.Caption = "Enable"
End Sub

Private Sub DisplayText(str)
    txtCom1.Text = txtCom1.Text & str
    txtCom1.Refresh
    txtCom1.SelStart = Len(txtCom1.Text)                    ' puts cursor at the end of the text
End Sub

Private Sub GetFile()
Dim fname As String
Dim fileno As Integer
Dim filesize As Long
Dim bytes() As Byte
Dim i, k, n As Long
Dim blksize As Long
Dim chksum As Long
Dim str, s1 As String

'Get file from prop/sd to PC
    LocateFile (True)
    If CommonDialog1.FileName = "" Then Exit Sub
    ' we now have control so block mainloop
    bMainLoop = False
    
    fname = CommonDialog1.FileName
    fname = Mid(fname, InStrRev(fname, "\") + 1)                ' remove the path
    
'    fname = "LICENSEG.TXT"                                      ' force name!!!=========
    
    str = "GET " & fname & vbCrLf
    MSComm1.Output = str
    s1 = ReadCommPort(Len(str) - 2)                             ' wait for the echo (ex crlf)
    DisplayText (s1 & vbCrLf)
    
    ' now wait for "A"ck, "T"erminate or SD">" (crlf should still be in the buffer)
    i = 0
    Do
        str = ReadCommPort(0)                                   ' dummy - just waits and fills buf if a char
        If (Len(buf) > 0) Then
            str = ReadCommPort(1)                               ' read a char
'Debug.Print Asc(str)
            Select Case str
                Case "A"
                Case "T", ">"
                    DisplayText (vbCrLf & "T) *** FILE NOT FOUND ***" & vbCrLf)
                    CloseCommPort
                    Exit Sub
                Case Else
                    i = i + 1
                    If i > 5 Then
                        DisplayText (vbCrLf & "T) *** TRANSFER FAILED TO START ***" & vbCrLf)
                        CloseCommPort
                        Exit Sub
                    End If
            End Select
        End If
    Loop Until str = "A"
    
    ' recv the file data
    DisplayText ("i) Receiving.")
    filesize = 0
    ' receive data block(s)
    k = 13                                                      ' len("i) Receiving.")
    Do
        str = ReadCommPort(2)                                   ' wait for block size
'       blksize = Asc(Mid(str, 1, 1)) + (256 * Asc(Mid(str, 2, 1)))       ' get this block size
        n = Asc(Mid(str, 2, 1))                                 '\\ convert... (above does not work! lge vals)
        n = n * 256                                             '|| ...
        n = n + Asc(Mid(str, 1, 1))                             '|| ...
        blksize = n                                             '// ...
        chksum = 0
        filesize = filesize + blksize                           ' accum the size
        ' check blocksize <> 0 (EOF)
        If blksize > 0 Then
            str = ReadCommPort(blksize)                         ' wait for the data block
            ' copy data to bytes
            ReDim Preserve bytes(1 To filesize)                 ' make correct size (keep existing data)
            n = filesize - blksize                              ' set to previous filesize
            For i = 1 To blksize
                bytes(n + i) = Asc(Mid(str, i, 1))              ' copy data block to array
                chksum = chksum + Asc(Mid(str, i, 1))           ' calc checksum
            Next i
        End If
        DisplayText (".")
        k = k + 1
        If k > 40 Then
            k = 0
            DisplayText (vbCrLf)
        End If
        ' acknowledge with checksum
        MSComm1.Output = Chr(chksum Mod 256)                    ' send checksum Lo
        MSComm1.Output = Chr((chksum \ 256) Mod 256)            '               Hi
'Debug.Print "Checksum=" & chksum & ": " & Asc(Chr(chksum Mod 256)) & "+" & Asc(Chr((chksum \ 256) Mod 256))
    Loop While blksize > 0
    
    str = ReadCommPort(1)                                       ' wait for final ACK
    If (str <> "A") Then
        DisplayText (str & vbCrLf)
        DisplayText ("T) *** NO 'ACK' RECEIVED ***" & vbCrLf)
        CloseCommPort
        Exit Sub
    End If
    
    ' Write file
    DisplayText (vbCrLf & "i) Writing..." & vbCrLf)
    fileno = FreeFile
    Open fname For Binary Access Write As fileno
    Put fileno, , bytes                                         ' puts complete binary file
    Close fileno

    DisplayText ("i) File " & fname & " written to PC, " & filesize & " bytes." & vbCrLf)
    MSComm1.Output = "E"                                        ' send final END
    buf = ""                                                    ' cleardown buffers...
End Sub

Private Sub PutFile()
Dim fname As String
Dim fileno As Integer
Dim filesize As Long
Dim bytes() As Byte
Dim i, k, n As Long
Dim blksize As Long
Dim origsize As Long
Dim chksum As Long
Dim str, s1 As String

'Put file from PC to prop/sd
    LocateFile (False)
    If CommonDialog1.FileName = "" Then Exit Sub
    ' we now have control so block mainloop
    bMainLoop = False

    fname = CommonDialog1.FileName
    fname = Mid(fname, InStrRev(fname, "\") + 1)                ' remove the path
    
'    fname = "LICENSEP.TXT"                                      ' force name!!!=========
    
    ' Read file
    DisplayText (vbCrLf & "i) Opening..." & vbCrLf)
    fileno = FreeFile
    filesize = FileLen(fname)                                   ' Returns file length (bytes)
    ReDim bytes(0 To filesize - 1)                              ' make correct size
    Open fname For Binary Access Read As fileno
    Get fileno, , bytes                                         ' gets complete binary file
    Close fileno
    DisplayText ("i) File " & fname & " read, " & filesize & " bytes." & vbCrLf)
    
    str = "PUT " & fname & vbCrLf
    MSComm1.Output = str
    s1 = ReadCommPort(Len(str) - 2)                             ' wait for the echo (ex crlf)
    DisplayText (s1 & vbCrLf)
    
    ' now wait for "A"ck, "T"erminate or SD">" (crlf should still be in the buffer)
    i = 0
    Do
        str = ReadCommPort(0)                                   ' dummy - just waits and fills buf if a char
        If (Len(buf) > 0) Then
            str = ReadCommPort(1)                               ' read a char
'Debug.Print Asc(str)
            Select Case str
                Case "A"
                Case "T", ">"
                    DisplayText (vbCrLf & "T) *** FILE NOT FOUND ***" & vbCrLf)
                    CloseCommPort
                    Exit Sub
                Case Else
                    i = i + 1
                    If i > 5 Then
                        DisplayText (vbCrLf & "T) *** TRANSFER FAILED TO START ***" & vbCrLf)
                        CloseCommPort
                        Exit Sub
                    End If
            End Select
        End If
    Loop Until str = "A"
    
    ' send file data
    DisplayText ("i) Sending...")
    blksize = comsize                                           ' set default comm block size
    origsize = filesize                                         ' save orig filesize
    filesize = 0
'Debug.Print "Filesize: " & origsize
    ' send data block(s)
    k = 13                                                      ' len("i) Sending...")
    Do
        n = origsize - filesize                                 ' size remaining
        If n < blksize Then blksize = n                         ' reduce last block size?
        MSComm1.Output = Chr(blksize Mod 256)                   ' send blocksize Lo
        MSComm1.Output = Chr((blksize \ 256) Mod 256)           '                Hi
'Debug.Print "Blocksize=" & blksize & ": " & Asc(Chr(blksize Mod 256)) & "+" & Asc(Chr((blksize \ 256) Mod 256))
        chksum = 0
        ' check blocksize <> 0 (EOF)
        If blksize > 0 Then
            ' copy bytes to string and send block
            str = ""
            For i = filesize To (filesize + blksize - 1)
                str = str & Chr(bytes(i))
                chksum = chksum + bytes(i)                    ' calc checksum
            Next i
            MSComm1.Output = str                                ' send data block
            filesize = filesize + blksize                       ' accum the size sent
        End If
        DisplayText (".")
        k = k + 1
        If k > 40 Then
            k = 0
            DisplayText (vbCrLf)
        End If
        ' recv checksum
        str = ReadCommPort(2)                                   ' wait for checksum
'       n = Asc(Mid(str, 1, 1)) + (256 * Asc(Mid(str, 2, 1)))   ' ...convert
        n = Asc(Mid(str, 2, 1))                                 '\\ convert... (above does not work! lge vals)
        n = n * 256                                             '|| ...
        n = n + Asc(Mid(str, 1, 1))                             '// ...
'Debug.Print "Checksum=" & chksum & "=" & n & ": " & Asc(Mid(str, 1, 1)) & "+" & Asc(Mid(str, 2, 1))
''        n = chksum              '!!!!!!!========== force checksum
        If chksum <> n Then                                     ' ...validate
            DisplayText (vbCrLf & "T) *** CHECKSUM ERROR ***" & vbCrLf)
            MSComm1.Output = "T"
            CloseCommPort
            Exit Sub
        End If
    Loop While blksize > 0
    
    DisplayText (vbCrLf & "i) " & filesize & " bytes sent" & vbCrLf)
    MSComm1.Output = "A"                                        ' send ACK
    
    str = ReadCommPort(1)                                       ' wait for the END
    If (str <> "E") Then
        DisplayText (str & vbCrLf)
        DisplayText ("T) *** NO 'END' RECEIVED ***" & vbCrLf)
        CloseCommPort
        Exit Sub
    End If
    
    ' display final message (whatever is in the buffer)
    str = ReadCommPort(0)                                       ' dummy - just waits and fills buf if a char
    DisplayText (buf & vbCrLf)                                  ' display what's in buf
    buf = ""                                                    ' ...and clear
End Sub

Private Sub LocateFile(bGet)
    CommonDialog1.Filter = "Data (*.dat)|*.dat|Code (*.bin)|*.bin|All (*.*)|*.*"
    If bGet Then
        ' get from prop/sd so it may not exist on the pc
        CommonDialog1.DialogTitle = "Select PC File to Receive"
        CommonDialog1.Flags = cdlOFNCreatePrompt
        CommonDialog1.Flags = cdlOFNOverwritePrompt
    Else
        ' put to prop/sd so it must exist on the pc
        CommonDialog1.DialogTitle = "Select PC File to Send"
        CommonDialog1.Flags = cdlOFNFileMustExist
    End If
    CommonDialog1.ShowOpen
End Sub

